
package body Taylors is

  function IsScalar(P: Taylor) return Boolean is
  begin
    return False;
  end IsScalar;

  function CMonom(K: Natural; S: Scalar) return Taylor is
    P: Taylor;
  begin
    if K>PDeg then raise Constraint_Error; end if;
    for J in Index loop
      P(J) := ScalZero;
    end loop;
    P(K) := S;
    return P;
  end CMonom;

  function EMonom(S: Scalar) return Taylor is
    P: Taylor;
  begin
    for J in Power loop
      P(J) := ScalZero;
    end loop;
    P(Size) := Ball(S);
    return P;
  end EMonom;

  function Component(K: Natural; P: Taylor) return Scalar is
  begin
    if K>PDeg then raise Constraint_Error; end if;
    return P(K);
  end Component;

  procedure SetComponent(K: in Natural; S: in Scalar; P: in out Taylor) is
  begin
    if K>PDeg then raise Constraint_Error; end if;
    P(K) := S;
  end SetComponent;

  function ErrComp(P: Taylor) return Scalar is
  begin
    if Trunc then return ScalZero; end if;
    return P(Size);
  end ErrComp;

  procedure SetErrComp(S: in Scalar; P: in out Taylor) is
  begin
    P(Size) := S;
  end SetErrComp;

  function IsZero(P: Taylor) return Boolean is
  begin
    for K in Power loop
      if P(K) /= ScalZero then return False; end if;
    end loop;
    return Trunc or else P(Size)=ScalZero;
  end IsZero;

  function ZeroErr(P: Taylor) return Boolean is
  begin
    return P(Size)=ScalZero;
  end ZeroErr;

end Taylors;
